;Rab
;RR2-1;*********************************************************
;   PIC16F84    DS1821 
; ..  2001.
;********************************************************* 

	

 ; 16F84                DS1821 ( PR35)
 ; PORTB, Bit 4 --------DQ ( 1)
 ; PORTB, Bit 0 --------DQ ( 2)

       LIST p=16F84a
#include <p16f84a.inc>
      __CONFIG   03FFEH

;   PIC16C84,   
; #include <p1684.inc>

        constant DATA_PIN=4     ;   
        constant DATA_PIN2=0	;  DS1821
;-------------------------------------------
        CBLOCK  0CH

        T_C             ;     1
    	T_C2		;     2
        _N              ;    
        O_BYTE          ;     1
        I_BYTE          ;     1
        O_BYTE2         ;     2
        I_BYTE2         ;     2
        LOOP3		;              
        LOOP2           ;
        LOOP1         	;  
        TEMP		;
    	TEMP2 		;
    	LCDINFO		;    
    	DISPDATA	;    
    	LCDTIME		;   
        LSD		;     1
        MSD		;     1
    	LSD2		;     2
    	MSD2		;     2
        SIGN1           ;    1 
        SIGN2           ;    2 

        ENDC
;-------------------------------------------
;       161
;-------------------------------------------
LCDDATA	equ	PORTA	; i/o RA0-RA3 = 4-bit  
LCDCTRL	equ	PORTB	;  
DISP_E  equ     1       ;  /
DISP_RW equ     2       ; / 
DISP_RS equ     3       ;   
BF_FLAG	equ	1	;   
I_FLAG	equ 2	;   (/)

;********************************************
;	
;********************************************
PORTALO	macro  ;   LCDINIT-PORTALO-  LCDINIT
    	bsf     STATUS,RP0      ;   1  
    	movlw   b'11100000'     ;    
    	movwf   TRISA           ; 
    	bcf     STATUS,RP0      ;    0
    	endm
;-------------------------------------------
PORTAHI	macro
    	bsf     STATUS,RP0      ;   1  
    	movlw   b'11101111'     ;    
    	movwf   TRISA           ; 
    	bcf     STATUS,RP0      ;    0
    	endm
;-------------------------------------------
;      ,  6 
;  E
;-------------------------------------------
CLKDISP	macro
     	bsf	LCDCTRL,DISP_E	;      1
    	bcf	LCDCTRL,DISP_E	;      0
    	endm
;-------------------------------------------
DISPCLR	macro
    	movlw   b'00000001'     ;  
    	call    SENDI           ;    
    	endm
;-------------------------------------------
LINE1	macro
    	movlw	b'10000000'	;    1- 
    	call	SENDI		; 1- 
    	endm			; 
;-------------------------------------------
LINE2	macro
    	movlw	b'11000000'	;    1- 
    	call	SENDI		; 2-  (   9 
    	endm			;  )
;-------------------------------------------
LCDINIT	macro
	PORTALO			;     
    	movlw   0xF0            ;  15    
    	call    LCDWAIT		; 
    	movlw   b'00000010'     ;  4-  
    	movwf	LCDCTRL		;    B
	CLKDISP		        ;    
    	movlw   d'5'            ;  5 
    	call    LCDWAIT		; 
    	movlw   b'00101000'     ;  4-   2- 
    	call    SENDI           ; 
    	movlw   b'00101000'     ;  4-   2- 
    	call    SENDI           ; 
    	movlw   b'00001000'     ;  
    	call    SENDI           ; 
	DISPCLR
    	movlw   b'00001100'     ;  
    	call    SENDI           ; 
    	movlw   b'00000110'     ;     
    	call    SENDI           ; 
    	movlw	40		;   
    	call	SENDI		;   0
    	movlw	1C
    	call	SENDD
    	movlw	14
    	call	SENDD
    	movlw	1C
    	call	SENDD
    	clrw
    	call	SENDD
    	clrw
    	call	SENDD
    	clrw
    	call	SENDD
    	clrw
    	call	SENDD
    	clrw
    	call	SENDD
    	movlw	80
    	call	SENDI
    	endm

;******************************************************
;  
;******************************************************
        ORG 000H
        goto MAIN
        org     4
        goto    int
MAIN:
        clrf	PORTA		;   
    	clrf	PORTB		;   
    	bsf	STATUS,RP0	;  1 
    	bcf	OPTION_REG,NOT_RBPU ;  
    	movlw	b'11100000'	;     
    	movwf	TRISA		; 
    	movlw	b'11000001'	;     
    	movwf	TRISB
    	bcf	STATUS,RP0	;    2 
        LCDINIT			;  ,  
        call 	CONFIG_DEVICE   ;   1
        call 	CONFIG_DEVICE2  ;   2, 22379-12=22367
MAIN_1:
        call 	START_CONVERT   ;    1
        call 	READ_TEMP       ;   1
        movwf 	T_C             ;     _
        call 	STOP_CONVERT    ;    1
    	btfsc	T_C,7		;   
    	goto	minus		;   7=1,   "-"
plus	movlw	'+'		;   "+"
    	movwf	SIGN1		;  "+"  
disp    call 	DISPLAY         ;    
        movlw   4               ;  1 
        movwf 	LOOP3
MAIN_2:
        call 	DELAY_LONG
        decfsz 	LOOP3, F
        goto 	MAIN_2
;-----------------------------------------------
;       
;-----------------------------------------------
MAIN_3:
        call 	START_CONVERT2
        call 	READ_TEMP2
        movwf 	T_C2
        call 	STOP_CONVERT2
    	btfsc	T_C2,7
    	goto	minus2
plus2	movlw	'+'
    	movwf	SIGN2
disp2	call 	DISPLAY2
    	movlw   4
        movwf 	LOOP3
MAIN_4:
        call 	DELAY_LONG
        decfsz 	LOOP3, F
        goto 	MAIN_4
        goto 	MAIN_1		;   1- 
;-----------------------------------------
minus	movlw	'-'		;  "-"
    	movwf	SIGN1		;  
    	movf	T_C,w		;  
    	sublw	0FF		;   -
    	addlw	1		;    
    	movwf	T_C		;  
    	goto	disp

minus2	movlw	'-'		;    2- 
    	movwf	SIGN2
    	movf	T_C2,w
    	sublw	0FF
    	addlw	1
    	movwf	T_C2
    	goto	disp2
;----------------------------------------
CONFIG_DEVICE:
        call 	INIT
        movlw 	0CH
        movwf 	O_BYTE
        call 	OUT_BYTE
        movlw 	03H             ;  ,   1
        movwf 	O_BYTE
        call 	OUT_BYTE
        movlw 	.20             ;  20    
        movwf 	LOOP1
        call 	DELAY_N_MS      ; 2494 -12  = 2482
        return

CONFIG_DEVICE2:			;     1
        call 	INIT2
        movlw 	0CH
        movwf 	O_BYTE2
        call 	OUT_BYTE2
        movlw 	03H 
        movwf 	O_BYTE2
        call 	OUT_BYTE2
        movlw 	.20 
        movwf 	LOOP1
        call 	DELAY_N_MS   ;24861
        return
;---------------------------------------

START_CONVERT:
        call	INIT
        movlw 	0EEH
        movwf 	O_BYTE
        call 	OUT_BYTE
        movlw 	.100            ;  100 
        movwf 	LOOP1
        call 	DELAY_N_MS
        return

START_CONVERT2:
        call 	INIT2
        movlw 	0EEH
        movwf 	O_BYTE2
        call 	OUT_BYTE2
        movlw 	.100
        movwf 	LOOP1
        call 	DELAY_N_MS
        return
;---------------------------------------
READ_TEMP:
        call 	INIT
        movlw 	0AAH
        movwf 	O_BYTE
        call 	OUT_BYTE
        call 	IN_BYTE
        movf 	I_BYTE, W
        return

READ_TEMP2:
        call 	INIT2
        movlw 	0AAH
        movwf 	O_BYTE2
        call 	OUT_BYTE2
        call 	IN_BYTE2
        movf 	I_BYTE2, W
        return
;---------------------------------------
STOP_CONVERT:
        call 	INIT
        movlw 	22H
        movwf 	O_BYTE
        call 	OUT_BYTE
        return

STOP_CONVERT2:
        call 	INIT2
        movlw 	22H
        movwf 	O_BYTE2
        call 	OUT_BYTE2
        return
;---------------------------------------
DISPLAY:
	LINE1
    	movlw	0A9		; ""
    	call	SENDD
    	movlw	0BB		; ""
    	call	SENDD
    	movlw	'.'		; "."
    	call	SENDD
    	movf	SIGN1,w		;  "+"  "-"
    	call	SENDD
    	movf	T_C,w
    	call 	BINBCD		;    
    	movf	MSD,W		;   
    	addlw	30
    	call	SENDD
    	movf	LSD,W		;   
    	addlw	30
    	call	SENDD
    	movlw	0		;   
    	call	SENDD
    	movlw	' '		; 
    	call	SENDD
    	return

DISPLAY2
	LINE2
    	movlw	0E0		; ""
    	call	SENDD
    	movlw	'o'		; ""
    	call	SENDD
    	movlw	0BC		; ""
    	call	SENDD
    	movlw	' '		; 
    	call	SENDD
    	movf	SIGN2,w
    	call	SENDD
    	movf	T_C2,w
    	call	BINBCD2
    	movf	MSD2,W
    	addlw	30
    	call	SENDD
    	movf	LSD2,W
    	addlw	30
    	call	SENDD
    	movlw	0		;   
    	call	SENDD	
        return
;-------------------------------------------
;     1-Wire
;-------------------------------------------
INIT:
        call    PIN_HI
        call    PIN_LO
        movlw   .50              ;  500 
        call 	DELAY_10USEC
        call    PIN_HI
        movlw   .50              ;  500 
        call 	DELAY_10USEC
        return

INIT2:
        call    PIN_HI2
        call    PIN_LO2
        movlw   .50              ;  500 
        call	DELAY_10USEC
        call    PIN_HI2
        movlw   .50              ;  500 
        call 	DELAY_10USEC
        return
;-------------------------------------------
WAIT:
        call    IN_BYTE
        movlw   0FFH
        subwf   I_BYTE, W
        btfss   STATUS, Z
        goto    WAIT
        return

WAIT2:
        call    IN_BYTE2
        movlw   0FFH
        subwf   I_BYTE2, W
        btfss   STATUS, Z
        goto    WAIT2
        return
;-------------------------------------------
IN_BYTE:              		;    W 
        movlw   .8
        movwf    _N
        clrf    I_BYTE
IN_BYTE_1:
        call 	PIN_LO
        nop
        call 	PIN_HI
        nop
        nop
        nop
        nop
        nop
        nop
        movf    PORTB, W        ; 7  ,   DATA PIN
        movwf   TEMP
        btfss   TEMP, DATA_PIN
        bcf 	STATUS, C       ;  

        btfsc   TEMP, DATA_PIN
        bsf 	STATUS, C       ;  
        rrf     I_BYTE, F
        movlw 	.6              ;   60 
        call    DELAY_10USEC
        decfsz  _N, F
        goto    IN_BYTE_1
        movfw   I_BYTE          ;    W
        return

IN_BYTE2:              		;    W
        movlw   .8
        movwf    _N
        clrf    I_BYTE2
IN_BYTE_12:
        call 	PIN_LO2         ;    DATA_PIN
        nop
        call 	PIN_HI2
        nop
        nop
        nop
        nop
        nop
        nop
        movf    PORTB, W        ; 7  ,   DATA PIN
        movwf   TEMP2
        btfss   TEMP2, DATA_PIN2
        bcf 	STATUS, C       ;  
        btfsc   TEMP2, DATA_PIN2
        bsf 	STATUS, C       ;  
        rrf     I_BYTE2, F
        movlw 	.6              ;   60 
        call    DELAY_10USEC
        decfsz  _N, F
        goto    IN_BYTE_12
        movfw   I_BYTE2          ;    W
        return
;------------------------------------------
OUT_BYTE:
        movlw   .8
        movwf   _N
OUT_BYTE_1:
        rrf     O_BYTE, F
        btfss   STATUS, C
        goto    OUT_0
        goto    OUT_1
OUT_BYTE_2:
        decfsz  _N, F
        goto    OUT_BYTE_1
        return

OUT_BYTE2:
        movlw   .8
        movwf   _N
OUT_BYTE_12:
        rrf     O_BYTE2, F
        btfss   STATUS, C
        goto    OUT_02
        goto    OUT_12
OUT_BYTE_22:
        decfsz  _N, F
        goto    OUT_BYTE_12
        return
;-------------------------------------------
OUT_0:
        call    PIN_LO          ;  DATA PIN 
        movlw   .6              ;   60 
        call    DELAY_10USEC
        call    PIN_HI
        goto    OUT_BYTE_2
OUT_1:
        call    PIN_LO          ;  
        call    PIN_HI
        movlw 	.6
        call 	DELAY_10USEC
        goto    OUT_BYTE_2

;--------------------------------------------------------------------
;         
;--------------------------------------------------------------------

PIN_HI:
        bsf     STATUS, RP0
        bsf     TRISB, DATA_PIN ;     
        bcf     STATUS, RP0
        return
OUT_02:
        call    PIN_LO2          ;  DATA PIN 
        movlw   .6               ;   60 
        call    DELAY_10USEC
        call    PIN_HI2
        goto    OUT_BYTE_22
OUT_12:
        call    PIN_LO2          ;  
        call    PIN_HI2
        movlw 	.6
        call 	DELAY_10USEC
        goto    OUT_BYTE_22

;---------------------------------------

PIN_HI2:
        bsf     STATUS, RP0
        bsf     TRISB, DATA_PIN2  ;  
        bcf     STATUS, RP0
        return
;---------------------------------------
;   0  DATA_PIN-RB4-10    
; DATA_PIN2-RB0-6  ,      
;     .
;---------------------------------------
PIN_LO:
        bcf     PORTB, DATA_PIN
        bsf     STATUS, RP0
        bcf     TRISB, DATA_PIN    ;   
        bcf     STATUS, RP0
        return
PIN_LO2:
        bcf     PORTB, DATA_PIN2
        bsf     STATUS, RP0
        bcf     TRISB, DATA_PIN2    ;   
        bcf     STATUS, RP0
        return
;---------------------------------------
DELAY_LONG
        movlw 	.250      ;  250 
        movwf 	LOOP1
DELAY_N_MS:
OUTTER:
        movlw   .110      ;  1 
        movwf   LOOP2
INNER:
        nop
        nop
        nop
        nop
        nop
        nop
        decfsz  LOOP2, F
        goto 	INNER
        decfsz  LOOP1, F
        goto 	OUTTER
        return           ; = 19879    22375
;---------------------------------------
;      W *10 = !
;---------------------------------------
DELAY_10USEC:   	;   W * 10 
        movwf 	LOOP1
DELAY_10USEC_1:
        nop
        nop
        nop
        nop 
        nop
        nop
        nop
        decfsz 	LOOP1, F
        goto 	DELAY_10USEC_1
        return
;********************************************
;     
;********************************************
SENDI:
    	bsf	LCDINFO,I_FLAG	;   
SENDD:
    	movwf   DISPDATA        ;   -   
	PORTAHI			;  PortA Tristate
    	bcf	LCDCTRL,DISP_RS	; RS=0 => 
    	bsf	LCDCTRL,DISP_RW	; RW=1 => 
DISPBUSY:
    	bsf	LCDCTRL,DISP_E	;     -DATA
    	bcf     LCDINFO,BF_FLAG	;  , , = 0
    	btfsc   PORTA,3         ;     
    	bsf     LCDINFO,BF_FLAG	;    = 1
    	bcf	LCDCTRL,DISP_E	;    
	CLKDISP			;      
    	btfsc   LCDINFO,BF_FLAG ; ,   
    	goto    DISPBUSY        ;   
	PORTALO			;  portA    
    	bsf	LCDCTRL,DISP_RS	; RS=1 => 
    	bcf	LCDCTRL,DISP_RW	; RW=0 => 
    	btfsc   LCDINFO,I_FLAG	; ,  ?
    	bcf	LCDCTRL,DISP_RS	; , RS=0 => 
    	swapf   DISPDATA,W      ;       W
    	movwf   LCDDATA		;     portA
	CLKDISP			;      
    	movf    DISPDATA,W      ;      W
    	movwf	LCDDATA		;     portA
	CLKDISP			;      
    	bcf     LCDINFO,I_FLAG	;  ,   SEND
    	return
;----------------------------------------
LCDWAIT:
    	clrf	LCDTIME		;    
LCDWAITLOOP:
    	nop			;    256
    	decfsz	LCDTIME,F	;  Decrement
    	goto	LCDWAITLOOP	;  ,     
    	movwf	LCDTIME		; W    
    	decfsz	LCDTIME,W	; Decrement
    	goto	LCDWAIT
    	return
;-------------------------------------
BINBCD:	
    	clrf 	MSD
    	movf	T_C,w
    	movwf	LSD
GTENTH:
    	movlw	d'10'
    	subwf	LSD,W
    	btfss	STATUS,C
    	goto	OVER
    	movwf	LSD
    	incf	MSD,F
    	goto	GTENTH
OVER:	retlw	0

BINBCD2:	
    	clrf 	MSD2
     	movf	T_C2,w
    	movwf	LSD2
GTENTH2:
    	movlw	d'10'
    	subwf	LSD2,W
    	btfss	STATUS,C
    	goto	OVER2
    	movwf	LSD2
    	incf	MSD2,F
    	goto	GTENTH2
OVER2:	retlw	0
;------------------------------------
int:    retfie
;*************************************************
        END


